// Shake it to wake it program top load
// Operation of the liquide valves and that sort of thing

// Include any librarys
#include <Servo.h>

// Define our inputs
#define in_coffee  A0
#define in_vodka A1
#define in_liquiur A2
#define in_pipeSwash A3
#define in_lid A4

// Name each of the servos
Servo coffee;
Servo vodka;
Servo liquiur;
Servo pipeSwash;
Servo lid;

// Define the limits of each servo
int coffee_hi = 180;
int coffee_lo = 0;
int vodka_hi = 180;
int vodka_lo = 0;
int liquiur_hi = 180;
int liquiur_lo = 0;
int pipeSwash_hi = 90;
int pipeSwash_lo = 180;
int lid_hi = 180;
int lid_lo = 0;


void setup() {
  // Attach each of the servo objects to a pin
  coffee.attach(3);
  vodka.attach(5);
  liquiur.attach(6);
  pipeSwash.attach(9);
  lid.attach(10);

  // Set input pin modes
  pinMode(in_coffee, INPUT);
  pinMode(in_vodka, INPUT);
  pinMode(in_liquiur, INPUT);
  pinMode(in_pipeSwash, INPUT);
  pinMode(in_lid, INPUT);

  // Set the servos to their low positions
  coffee.write(coffee_lo);

  Serial.begin(9600);
  Serial.println("Start");

}

void loop() {
  // Check each input and respond
  if (digitalRead(in_coffee)) {
    ssweep(coffee, coffee_hi);
  }
  else {
    ssweep(coffee, coffee_lo);
  }

  if (digitalRead(in_vodka)) {
    ssweep(vodka, vodka_hi);
  }
  else {
    ssweep(vodka, vodka_lo);
  }

  if (digitalRead(in_liquiur)) {
    ssweep(liquiur, liquiur_hi);
  }
  else {
    ssweep(liquiur, liquiur_lo);
  }

  if (digitalRead(in_pipeSwash)) {
    ssweep(pipeSwash, pipeSwash_hi);
  }
  else {
    ssweep(pipeSwash, pipeSwash_lo);
  }

  if (digitalRead(in_lid)) {
    ssweep(lid, lid_hi);
  }
  else {
    ssweep(lid, lid_lo);
  }

  // Debug output
  Serial.println("Inputs");
  Serial.print("--> Coffee = ");
  Serial.println(digitalRead(in_coffee));
  Serial.print("--> Vodka = ");
  Serial.println(digitalRead(in_vodka));
  Serial.print("--> Liquiur = ");
  Serial.println(digitalRead(in_liquiur));
  Serial.print("--> Pipe Swash = ");
  Serial.println(digitalRead(in_pipeSwash));
  Serial.print("--> Lid = ");
  Serial.println(digitalRead(in_lid));
    
}


// Servo sweeping function
void ssweep(Servo &id, int to) {

  // Declarations
  int from;

  // Get where it currently is
  from = id.read();

  // Check if we are already there
  if (to == from) {
    // Don't do anything
    return;
  }

  Serial.println("Move Start");

  // Now move it nicely
  if (from < to) {
    for (int i=from; i <= to; i++){
      id.write(i);
      delay(5);
    }
  }
  else {
    for (int i=from; i >= to; i--){
      id.write(i);
      delay(5);
    }
  }

  Serial.println("Move Stop");
}

